SystemOrganization addCategory: #'Seaside-Tests-Security'!

!WAResponseTest methodsFor: '*seaside-tests-security' stamp: 'pmm 2/6/2014 16:09'!
testNoSniff
	self response noSniff.
	self assert: (self response headerAt: 'X-Content-Type-Options') = 'nosniff'.
	self assert: (self response headers size) = 1! !

!GRPackage class methodsFor: '*seaside-tests-security' stamp: 'pmm 2/8/2014 16:20'!
seasideTestsSecurity
	^ self new
		name: 'Seaside-Tests-Security';
		addDependency: 'Seaside-Security';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !

TestCase subclass: #WAStrictTransportSecurityFilterTest
	instanceVariableNames: 'filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Security'!

!WAStrictTransportSecurityFilterTest methodsFor: 'private' stamp: 'pmm 2/9/2014 12:13'!
newFilter
	^ WAStrictTransportSecurityFilter new! !

!WAStrictTransportSecurityFilterTest methodsFor: 'running' stamp: 'pmm 2/9/2014 12:12'!
setUp
	super setUp.
	filter := self newFilter! !

!WAStrictTransportSecurityFilterTest methodsFor: 'testing' stamp: 'pmm 2/9/2014 12:25'!
testRedirectNoSsl
	| context request response |
	request := WARequest method: 'GET' uri: '/login.do?username=admin'.
	request headers at: 'host' put: 'bank.com'.
	response := WABufferedResponse new.
	self deny: request isSsl.
	
	context := WARequestContext request: request response: response.
	[  filter handleFiltered: context ]
		on: WAResponseNotification
		do: [ :notification | ].
		
	self assert: response status = WAResponse statusFound.
	self assert: ((response headerAt: 'Location') beginsWith: 'https://')! !
